<?xml version="1.0" encoding="utf-8" ?>
<Feature SiLA2Version="1.0" FeatureVersion="1.0" MaturityLevel="Draft" Originator="com.madisoft" Category="reader"
        xmlns="http://www.sila-standard.org"
        xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
        xsi:schemaLocation="http://www.sila-standard.org https://gitlab.com/SiLA2/sila_base/raw/master/schema/FeatureDefinition.xsd">
    <Identifier>AbsorbanceReaderService</Identifier>
    <DisplayName>Absorbance Reader Service</DisplayName>
    <Description>SiLA 2 Device Absorbance Reader feature - Show basic operations for a device absorbance reader
        like reading from selected well of a plate and reading from all wells in a plate.
        Absorbance reading has a measurement property.
    </Description>
    <Command>
        <Identifier>AbsorbanceReadWell</Identifier>
        <DisplayName>Absorbance Read Well</DisplayName>
        <Description>Read and present data from one target well</Description>
        <Observable>No</Observable>
        <Parameter>
            <Identifier>TargetWell</Identifier>
            <DisplayName>Target Well</DisplayName>
            <Description>Address of the target well on the plate which the reader will try to find, reach
                and will try to read the well data.
            </Description>
            <DataType>
                <DataTypeIdentifier>WellAddress</DataTypeIdentifier>
            </DataType>
        </Parameter>
        <Response>
            <Identifier>WellOpticalDensity</Identifier>
            <DisplayName>Well Optical Density</DisplayName>
            <Description>Optical density of the well</Description>
            <DataType>
                <DataTypeIdentifier>OpticalDensity</DataTypeIdentifier>
            </DataType>
        </Response>
    </Command>
    <Command>
        <Identifier>AbsorbanceReadPlate</Identifier>
        <DisplayName>Absorbance Read Plate</DisplayName>
        <Description>Go through every plate well and read its result</Description>
        <Observable>Yes</Observable>
        <Response>
            <Identifier>ResultList</Identifier>
            <DisplayName>Result List Values</DisplayName>
            <Description>Result list of values of every well</Description>
            <DataType>
                <List>
                    <DataType>
                        <Structure>
                            <Element>
                                <Identifier>WellAddress</Identifier>
                                <DisplayName>WellAddress</DisplayName>
                                <Description />
                                <DataType>
                                    <DataTypeIdentifier>WellAddress</DataTypeIdentifier>
                                </DataType>
                            </Element>
                            <Element>
                                <Identifier>WellOpticalDensity</Identifier>
                                    <DisplayName>Well Optical Density</DisplayName>
                                    <Description>Optical density of the well</Description>
                                    <DataType>
                                        <DataTypeIdentifier>OpticalDensity</DataTypeIdentifier>
                                    </DataType>
                            </Element>
                        </Structure>
                    </DataType>
                </List>
            </DataType>
        </Response>
    </Command>
    <Property>
        <Identifier>MeasurementFilter</Identifier>
        <DisplayName>Measurement Filter</DisplayName>
        <Description>Measurement filter for Absorbance read</Description>
        <Observable>No</Observable>
        <DataType>
            <Constrained>
                <DataType>
                    <Basic>Integer</Basic>
                </DataType>
                <Constraints>
                    <Unit>
                        <Label>nanometer</Label>
                        <Factor>0.000000001</Factor>
                        <Offset>0</Offset>
                        <UnitComponent>
                            <SIUnit>Meter</SIUnit>
                            <Exponent>1</Exponent>
                        </UnitComponent>
                    </Unit>
                    <Set>
                        <Value>230</Value>
                        <Value>280</Value>
                        <Value>405</Value>
                        <Value>560</Value>
                        <Value>600</Value>
                    </Set>
                </Constraints>
            </Constrained>
        </DataType>
    </Property>
    <DataTypeDefinition>
        <Identifier>WellAddress</Identifier>
        <DisplayName>Well Address</DisplayName>
        <Description>Well address on the plate which the reader will try to find, reach and will try to read the well data.
            The plate is like a matrix of wells and every well has addess which is unique and consists of two parts:
            1. First part is a letter from A to Z and shows the well row of the matrix
            2. Second part is a positive number 1, 2, 3, ... which shows the column of the plate matrix
            Example: A1, A2, ..., B1, B2, ...
            This property defines the first part of the well address.
        </Description>
        <DataType>
            <Structure>
                <Element>
                    <Identifier>Row</Identifier>
                    <DisplayName>Row</DisplayName>
                    <Description>Row of the well address A, B, C, ...</Description>
                    <DataType>
                        <Constrained>
                            <DataType>
                                <Basic>String</Basic>
                            </DataType>
                            <Constraints>
                                <Length>1</Length>
                                <Pattern>[A-Z]</Pattern>
                            </Constraints>
                        </Constrained>
                    </DataType>
                </Element>
                <Element>
                    <Identifier>Column</Identifier>
                    <DisplayName>Column</DisplayName>
                    <Description>Column of the well address 1, 2, 3, ...</Description>
                    <DataType>
                        <Constrained>
                            <DataType>
                                <Basic>Integer</Basic>
                            </DataType>
                            <Constraints>
                                <MinimalInclusive>0</MinimalInclusive>
                            </Constraints>
                        </Constrained>
                    </DataType>
                </Element>
            </Structure>
        </DataType>
    </DataTypeDefinition>
    <DataTypeDefinition>
        <Identifier>OpticalDensity</Identifier>
        <DisplayName>Optical Density</DisplayName>
        <Description>
            Measurement of the optical density in fractional number range from 0.000 to 5.000.
            It is dimensionless.
        </Description>
        <DataType>
            <Constrained>
                <DataType>
                    <Basic>Real</Basic>
                </DataType>
                <Constraints>
                    <MinimalInclusive>0.000</MinimalInclusive>
                    <MaximalInclusive>5.000</MaximalInclusive>
                </Constraints>
            </Constrained>
        </DataType>
    </DataTypeDefinition>
</Feature>
